# Some cmake glue code.

macro(string_join var delimiter str_list)
    set(_ret "")
    foreach(_str ${str_list})
        if(_ret STREQUAL "")
            set(_ret "${_str}")
        else()
            set(_ret "${_ret}${delimiter}${_str}")
        endif()
    endforeach(_str ${str_list})
    foreach(_str ${ARGN})
        if(_ret STREQUAL "")
            set(_ret "${_str}")
        else()
            set(_ret "${_ret}${delimiter}${_str}")
        endif()
    endforeach(_str ${ARGN})
    set(${var} "${_ret}")
endmacro()

macro(string_split inputvar delimiter outputvar)
    set(${outputvar})
    set(_copy_inputvar "${inputvar}")
    string(LENGTH "${delimiter}" delimiter_length)
    while(_copy_inputvar)
        string(FIND "${_copy_inputvar}" "${delimiter}" position)
        string(SUBSTRING "${_copy_inputvar}" 0 "${position}" BAR)
        list(APPEND ${outputvar} "${BAR}")
        if(0 GREATER position)
            SET(_copy_inputvar "")
        else()
            string(SUBSTRING "${_copy_inputvar}" ${position} -1
                _copy_inputvar)
            string(SUBSTRING "${_copy_inputvar}" ${delimiter_length} -1
                _copy_inputvar)
        endif()
    endwhile(_copy_inputvar)
endmacro()
